Subject: Re: [httpwg/http-extensions] Scope Accept-CH opt-in to same origin (#373)

From: HTTP issue updates <[email-masked]>
Date: Fri, 06 Oct 2017 10:40:27 -0700

igrigorik commented on this pull request.

> @@ -101,9 +102,9 @@ A Client Hint request header field is a HTTP header field that is used by HTTP c
 
 ## Sending Client Hints
 
-Clients control which Client Hints are sent in requests, based on their default settings, user configuration and/or preferences. Implementers might provide user choice mechanisms so that users may balance privacy concerns with bandwidth limitations. Implementations specific to certain use cases or threat models might avoid transmitting these header fields altogether, or limit them to secure contexts or authenticated sessions. Implementers should be aware that explaining the privacy implications of passive fingerprinting or network information disclosure may be challenging.
+Clients control which Client Hints are sent in requests, based on their default settings, user configuration and/or preferences. The client and server, or an intermediate proxy, can use an opt-in mechanism outlined below to negotiate which fields should be sent to allow for efficient content adaption.

Ack, removed.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r143253398

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 06 Oct 2017 17:52:18 +0000 (UTC)

> @@ -127,28 +128,28 @@ For example:
   Accept-CH: DPR, Width, Viewport-Width
 ~~~
 
-When a client receives Accept-CH, or if it is capable of processing the HTML response and finds an equivalent HTML meta element, it can treat it as a signal that the application is interested in receiving specified request header fields that match the advertised field-values; subresource requests initiated as a result of processing the response from the server that includes the Accept-CH opt-in can include the request header fields that match the advertised field-values.
+When a client receives Accept-CH from a potentially trustworthy origin ({{SECURE-CONTEXTS}}), or if it is capable of processing the HTML response and finds an equivalent HTML meta element, it can treat it as a signal that the origin ({{RFC6454}}) is interested in receiving specified request header fields that match the advertised field-values; same-origin resource requests initiated as a result of processing the response from the server that includes the Accept-CH opt-in can include the request header fields that match the advertised field-values.

Ack, updated.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r143256247

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 06 Oct 2017 11:23:14 -0700

~~~ abnf7230
   Accept-CH-Lifetime = #delta-seconds
 ~~~
 
-The field-value indicates that the Accept-CH preference SHOULD be considered stale after its age is greater than the specified number of seconds.
+When a client receives Accept-CH-Lifetime from a potentially trustworthy origin ("opt-in origin"), the field-value indicates that the Accept-CH preference SHOULD be considered stale after its age is greater than the specified number of seconds, and if applicable, persisted as a double-keyed preference that combines the values of the opt-in origin and the potentially trustworthy origin of the resource that initiated the request that received the opt-in preference.

Ack, took a run at rewriting this.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r143263089

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 06 Oct 2017 18:27:49 +0000 (UTC)

-Implementers ought to provide mechanisms and policies to control how and when such hints are advertised. For example, they could require origin opt-in via Accept-CH; clear remembered opt-in, as set by Accept-CH-Lifetime, when site data, browsing history, browsing cache, or similar, are cleared; restrict delivery to same origin subrequests; limit delivery to requests that already carry identifying information (e.g. cookies); modify delivery policy when in an "incognito" or a similar privacy mode; enable user configuration and opt in, and so on.
+Implementers should consider both user and server controlled mechanisms and policies to control which Client Hints header fields are advertised:
+
+  - Implementers may provide user choice mechanisms so that users may balance privacy concerns with bandwidth limitations. However, implementers should also be aware that explaining the privacy implications of passive fingerprinting or network information disclosure to users may be challenging.
+  - Implementers should support double-keyed Client Hints opt-in requested by potentially trustworthy origins via Accept-CH and Accept-CH-Lifetime header fields, and clear remembered opt-in when site data, browsing history, browsing cache, or similar, are cleared.

Ack, updated.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r143264089

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 06 Oct 2017 18:25:44 +0000 (UTC)

-For example, sending Client Hints on all requests can make information about the user's environment available to origins that otherwise did not have access to this data, which may or may not be the desired outcome - e.g. this may enable an image optimization service to deliver a tailored asset, and it may reveal same information about the user to other origins that may not have had access to it before. Similarly, sending highly granular data, such as image and viewport width may help identify users across multiple requests. Restricting such field values to an enumerated range, where the user agent advertises a threshold value that is close but is not an exact representation of the current value, can help mitigate the risk of such fingerprinting.
+Transmitted Client Hints header fields should not provide new information that is otherwise not available to the application via HTML, CSS, or JavaScript.  Further, sending highly granular data, such as image and viewport width may help identify users across multiple requests. Restricting such field values to an enumerated range, where the advertised value is close but is not an exact representation of the current value, can help mitigate the risk of such fingerprinting as well as reduce possibility of unnecessary cache fragmentation.

Ack, updated.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r143263613

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 06 Oct 2017 18:37:59 +0000 (UTC)

-Implementers ought to provide mechanisms and policies to control how and when such hints are advertised. For example, they could require origin opt-in via Accept-CH; clear remembered opt-in, as set by Accept-CH-Lifetime, when site data, browsing history, browsing cache, or similar, are cleared; restrict delivery to same origin subrequests; limit delivery to requests that already carry identifying information (e.g. cookies); modify delivery policy when in an "incognito" or a similar privacy mode; enable user configuration and opt in, and so on.
+Implementers should consider both user and server controlled mechanisms and policies to control which Client Hints header fields are advertised:
+
+  - Implementers may provide user choice mechanisms so that users may balance privacy concerns with bandwidth limitations. However, implementers should also be aware that explaining the privacy implications of passive fingerprinting or network information disclosure to users may be challenging.
+  - Implementers should support double-keyed Client Hints opt-in requested by potentially trustworthy origins via Accept-CH and Accept-CH-Lifetime header fields, and clear remembered opt-in when site data, browsing history, browsing cache, or similar, are cleared.
+  - Implementations specific to certain use cases or threat models may avoid transmitting Client Hints header fields altogether or limit them to authenticated sessions only that already carry identifying information, such as cookies or referer data.
+
+Following the above recommendations should significantly reduce the risks of linkability and passive fingerprinting.

Ack, dropped.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r143266277

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 06 Oct 2017 11:38:03 -0700

This is a tricky one. Took an attempt at rewriting it -- ptal.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r143266289

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 06 Oct 2017 18:51:15 +0000 (UTC)

@martinthomson @mnot thanks for the feedback! Updated, ptal.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#issuecomment-334839975

---

From: HTTP issue updates <[email-masked]>
Date: Mon, 09 Oct 2017 17:19:07 -0700

Looks better.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#issuecomment-335323667

---

From: HTTP issue updates <[email-masked]>
Date: Mon, 09 Oct 2017 21:08:16 -0700

martinthomson commented on this pull request.

> @@ -127,28 +127,28 @@ For example:
 
-When a client receives Accept-CH, or if it is capable of processing the HTML response and finds an equivalent HTML meta element, it can treat it as a signal that the application is interested in receiving specified request header fields that match the advertised field-values; subresource requests initiated as a result of processing the response from the server that includes the Accept-CH opt-in can include the request header fields that match the advertised field-values.
+When a client receives an HTTP response, over a secure transport, that contains Accept-CH header field, or if it is capable of processing the HTML response and finds an equivalent HTML meta element, it can treat it as a signal that the origin ({{RFC6454}}) is interested in receiving specified request header fields that match the advertised field-values; same-origin resource requests initiated as a result of processing the response from the server that includes the Accept-CH opt-in can include the request header fields that match the advertised field-values.

This sentence needs to be split up for readability.  I think that you have many clauses here.  Client hints can be carried in HTTP headers.  The client will only send client hints if the origin explicitly indicates that it supports them.  The server indicates support using the Accept-CH header field.  Support can be indicated using Accept-CH that is carried in meta-equivalent tags in HTML.  The client will only send client hints for requests with an https scheme.

 ### The Accept-CH-Lifetime Header Field {#accept-ch-lifetime}
 
-Servers can ask the client to remember an origin-wide Accept-CH preference for a specified period of time to enable delivery of Client Hints on all subsequent requests to the origin ({{RFC6454}}), and on any requests initiated as a result of processing a response from the origin.
+Servers can ask the client to remember sent Accept-CH preference for a specified period of time, to enable delivery of Client Hints on subsequent requests to the server's origin ({{RFC6454}}).

"sent Accept-CH preference" is an odd grammatical construct.  How about simply "the set of client hints that the server supports (or prefers)"?

 ~~~ abnf7230
 
-The field-value indicates that the Accept-CH preference SHOULD be considered stale after its age is greater than the specified number of seconds.
+When a client receives an HTTP response, over a secure transport, that contains Accept-CH-Lifetime header field, the field-value indicates that the Accept-CH preference SHOULD be persisted and bound to the origin, and be considered stale after response's age ({{RFC7234}}, section 4.2) is greater than the specified number of seconds.

Same sentence structure as before.  Easier to read this time, but why not just come right out and say it?  A server's preferences regarding client hints MUST NOT be persisted for an origin that isn't HTTPS.

 ~~~ example
   Accept-CH: DPR, Width
   Accept-CH: Viewport-Width
   Accept-CH-Lifetime: 86400
 ~~~
 
-For example, based on the Accept-CH and Accept-CH-Lifetime example above, a user agent could persist an origin-wide Accept-CH preference for up to 86400 seconds (1 day). Then, if a request is initiated to the same origin before the preference is stale (e.g. as a result of a navigation to the origin, or fetching a subresource from the origin) the client could append the requested header fields (DPR, Width, and Viewport-Width in this example) to the request and any subresource requests initiated as a result of processing a response from same origin.
+For example, based on the Accept-CH and Accept-CH-Lifetime example above, which is received from bar.com in response to a resource request initiated by foo.com, both delivered over a secure transport: a user agent SHOULD persist an Accept-CH preference bound to foo.com, for requests initiated to bar.com from foo.com, for up to 86400 seconds (1 day); this preference SHOULD NOT extend to requests initiated to bar.com from other origins.

Use origins rather than names.  Also, foo.com is a real name and you should use foo.example.com instead.

> @@ -257,11 +257,15 @@ The Content-DPR response header field indicates to the client that the server ha
 
 # Security Considerations
 
-The request header fields defined in this specification expose information that is already available to Web applications in the browser runtime itself (e.g., using JavaScript and CSS). For example, the application can obtain viewport width, image display width, and device pixel ratio via JavaScript, or through the use of CSS media queries and unique resource URLs even if JavaScript is disabled. However, servers that gather this information through such mechanisms are typically observable (e.g., you can see that they're using JavaScript to gather it), whereas servers' use of the header fields introduced by this specification is not observable. Section 2.1 discusses potential mitigations.
+The request header fields defined in this specification, and those that extend it, expose information about the user's environment to enable proactive content negotiation. Such information may reveal new information about the user and implementers ought to consider the following considerations, recommendations, and best practices.

I don't think that the word "proactive" is correct.  "Proactive content negotiation" would involve the server taking extra action (like ringing your high school music teacher) to find out what you might prefer.  For example, "proactive" might be used to describe what the advertising industry does to ensure that you are provided with relevant advertising.

-For example, sending Client Hints on all requests can make information about the user's environment available to origins that otherwise did not have access to this data, which may or may not be the desired outcome - e.g. this may enable an image optimization service to deliver a tailored asset, and it may reveal same information about the user to other origins that may not have had access to it before. Similarly, sending highly granular data, such as image and viewport width may help identify users across multiple requests. Restricting such field values to an enumerated range, where the user agent advertises a threshold value that is close but is not an exact representation of the current value, can help mitigate the risk of such fingerprinting.
+Transmitted Client Hints header fields should not provide new information that is otherwise not available to the application via HTML, CSS, or JavaScript.  Further, sending highly granular data, such as image and viewport width may help identify users across multiple requests. Restricting such field values to an enumerated range, where the advertised value is close but is not an exact representation of the current value, can help reduce the risk of such linkability as well as reduce possibility of unnecessary cache fragmentation.

SHOULD NOT?  Also "via other means, such as using HTML, CSS, or JavaScript"

-Implementers ought to provide mechanisms and policies to control how and when such hints are advertised. For example, they could require origin opt-in via Accept-CH; clear remembered opt-in, as set by Accept-CH-Lifetime, when site data, browsing history, browsing cache, or similar, are cleared; restrict delivery to same origin subrequests; limit delivery to requests that already carry identifying information (e.g. cookies); modify delivery policy when in an "incognito" or a similar privacy mode; enable user configuration and opt in, and so on.
+Implementers should consider both user and server controlled mechanisms and policies to control which Client Hints header fields are advertised:
+
+  - Implementers may provide user choice mechanisms so that users may balance privacy concerns with bandwidth limitations. However, implementers should also be aware that explaining the privacy implications of passive fingerprinting or network information disclosure to users may be challenging.
+  - Implementers should support Client Hints opt-in, delivered over secure transport, as advertised by Accept-CH and Accept-CH-Lifetime header fields, and must clear remembered opt-in when site data, browsing history, browsing cache, or similar, are cleared.

The cache clearing thing appears here as an aside.  I think that you want a complete paragraph on this.  (And a MUST).

-Implementers ought to provide mechanisms and policies to control how and when such hints are advertised. For example, they could require origin opt-in via Accept-CH; clear remembered opt-in, as set by Accept-CH-Lifetime, when site data, browsing history, browsing cache, or similar, are cleared; restrict delivery to same origin subrequests; limit delivery to requests that already carry identifying information (e.g. cookies); modify delivery policy when in an "incognito" or a similar privacy mode; enable user configuration and opt in, and so on.
+Implementers should consider both user and server controlled mechanisms and policies to control which Client Hints header fields are advertised:
+
+  - Implementers may provide user choice mechanisms so that users may balance privacy concerns with bandwidth limitations. However, implementers should also be aware that explaining the privacy implications of passive fingerprinting or network information disclosure to users may be challenging.
+  - Implementers should support Client Hints opt-in, delivered over secure transport, as advertised by Accept-CH and Accept-CH-Lifetime header fields, and must clear remembered opt-in when site data, browsing history, browsing cache, or similar, are cleared.

Again with the ", delivered over secure transport,".

-Implementers ought to provide mechanisms and policies to control how and when such hints are advertised. For example, they could require origin opt-in via Accept-CH; clear remembered opt-in, as set by Accept-CH-Lifetime, when site data, browsing history, browsing cache, or similar, are cleared; restrict delivery to same origin subrequests; limit delivery to requests that already carry identifying information (e.g. cookies); modify delivery policy when in an "incognito" or a similar privacy mode; enable user configuration and opt in, and so on.
+Implementers should consider both user and server controlled mechanisms and policies to control which Client Hints header fields are advertised:
+
+  - Implementers may provide user choice mechanisms so that users may balance privacy concerns with bandwidth limitations. However, implementers should also be aware that explaining the privacy implications of passive fingerprinting or network information disclosure to users may be challenging.
+  - Implementers should support Client Hints opt-in, delivered over secure transport, as advertised by Accept-CH and Accept-CH-Lifetime header fields, and must clear remembered opt-in when site data, browsing history, browsing cache, or similar, are cleared.

The server opt-in isn't really a security mechanism.  The adversary here is the server.  I would remove this item from the list.

-Implementers ought to provide mechanisms and policies to control how and when such hints are advertised. For example, they could require origin opt-in via Accept-CH; clear remembered opt-in, as set by Accept-CH-Lifetime, when site data, browsing history, browsing cache, or similar, are cleared; restrict delivery to same origin subrequests; limit delivery to requests that already carry identifying information (e.g. cookies); modify delivery policy when in an "incognito" or a similar privacy mode; enable user configuration and opt in, and so on.
+Implementers should consider both user and server controlled mechanisms and policies to control which Client Hints header fields are advertised:
+
+  - Implementers may provide user choice mechanisms so that users may balance privacy concerns with bandwidth limitations. However, implementers should also be aware that explaining the privacy implications of passive fingerprinting or network information disclosure to users may be challenging.
+  - Implementers should support Client Hints opt-in, delivered over secure transport, as advertised by Accept-CH and Accept-CH-Lifetime header fields, and must clear remembered opt-in when site data, browsing history, browsing cache, or similar, are cleared.
+  - Implementations specific to certain use cases or threat models may avoid transmitting some or all of Client Hints header fields. For example, by limiting them to authenticated sessions only that already carry identifying information, such as cookies or referer data, and/or avoid transmission of header fields that carry higher risks of linkability.

This doesn't really work.  We don't regulate the use of cookies, so it is trivial for your adversary (the server) to construct a cookie if that causes the client hints to be sent to it.

If we scratch this and the second item, that reduces the entire set of protections to "ask the user", which isn't very satisfying.  Maybe there is something here that could be extracted, but this text doesn't do it.

Take one sort of coincidental signal that the user might generate: they actively choose to send a password to the server.  This might be argued to indicate that further identification is acceptable to that user.  But passwords are - if the user follows good practices - origin-specific, and so the act of sending a password does not inherently create linkability.

What you want to look for is a signal that the user is OK to link their activity here with activity elsewhere.  That's a whole lot harder, especially since we try really hard to avoid creating inadvertent or secondary signals like that.

-For example, sending Client Hints on all requests can make information about the user's environment available to origins that otherwise did not have access to this data, which may or may not be the desired outcome - e.g. this may enable an image optimization service to deliver a tailored asset, and it may reveal same information about the user to other origins that may not have had access to it before. Similarly, sending highly granular data, such as image and viewport width may help identify users across multiple requests. Restricting such field values to an enumerated range, where the user agent advertises a threshold value that is close but is not an exact representation of the current value, can help mitigate the risk of such fingerprinting.
+Transmitted Client Hints header fields should not provide new information that is otherwise not available to the application via HTML, CSS, or JavaScript.  Further, sending highly granular data, such as image and viewport width may help identify users across multiple requests. Restricting such field values to an enumerated range, where the advertised value is close but is not an exact representation of the current value, can help reduce the risk of such linkability as well as reduce possibility of unnecessary cache fragmentation.

This is better, but it fails to recognize that some information can leak, even when attempts are made to obscure it.  I would add a note saying something like "Reducing the set of values that can be expressed in client hints can improve privacy by ensuring that the same value is sent by multiple users, but this can be insufficient for some types of data, especially data that can change over time."  That would address my concern regarding the possibility of a Geolocation header field that is a client hint.  (I would retain a host of other concerns about such a proposal, but you can't be expected to address all of those here.)

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#pullrequestreview-68143056

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 13 Oct 2017 13:54:39 -0700

I believe we use "proactive" and "server-driven" interchangeably, so current language is OK. That said, I'll defer to @mnot and @mcmanus. 

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r144655023

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 13 Oct 2017 13:55:44 -0700

ack

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r144655221

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 13 Oct 2017 21:02:57 +0000 (UTC)

Thanks good suggestions, tried to rewrite and work this into current text.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r144656473

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 13 Oct 2017 14:08:13 -0700

Good call, mixing may/must's here.. Moved it into a separate section.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r144657398

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 13 Oct 2017 21:27:40 +0000 (UTC)

@igrigorik pushed 3 commits.

7d738c9  rework accept-ch / accept-ch-lifetime text
29065eb  use origins in example
b4ef4d0  integrate Martin's feedback for security section

-- 
You are receiving this because you are subscribed to this thread.
View it on GitHub:
https://github.com/httpwg/http-extensions/pull/373/files/4f046666a573a6fa7cf4d663f0ad07543afd19c3..b4ef4d00fe450fc09332332f25fb014bfa1fda7f

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 13 Oct 2017 14:27:40 -0700

The HTTPS requirement we're adding in this update helps scope down our list of adversaries: before we were also considering passive observers, now we're scoped to the response server.  With that in mind, good point on regulating cookies: with server as adversary it's not a meaningful protection.

That said, I think the broader "may avoid transmitting some or all of CH header fields" can be a valid recommendation. I'll drop the cookies and referrer text.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r144660500

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 13 Oct 2017 14:28:47 -0700

@martinthomson thanks for the thorough review (and patience :)), again! Updated, ptal.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#issuecomment-336571988

---

From: HTTP issue updates <[email-masked]>
Date: Wed, 25 Oct 2017 23:39:03 -0700

yoavweiss commented on this pull request.

Overall looks good. IIUC, the opt-ins are limited to secure transport, but the actual hints are not. Is that correct? If so, should we change it?

-The client and server, or an intermediate proxy, can use an opt-in mechanism to negotiate which fields should be reported to allow for efficient content adaption.
+Implementers should be be aware of the passive fingerprinting and network information disclosure implications when implementing support for Client Hints, and follow the considerations outlined in "Security Considerations" section of this document.

Nit: s/be be/be/

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#pullrequestreview-72088958

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 27 Oct 2017 11:15:58 -0700

Ack. Good catch.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#discussion_r147481229

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 27 Oct 2017 11:22:56 -0700

> the opt-ins are limited to secure transport, but the actual hints are not. Is that correct? If so, should we change it?

I don't think that's necessary. This is implicit due to requirement for opt-in over secure transport — i.e. only secure origins can opt-in to receive hints and HTTPS-only is the new default policy for all hints.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#issuecomment-340047817

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 27 Oct 2017 11:27:48 -0700

@igrigorik pushed 1 commit.

79e372c  fix typo

-- 
You are receiving this because you are subscribed to this thread.
View it on GitHub:
https://github.com/httpwg/http-extensions/pull/373/files/b4ef4d00fe450fc09332332f25fb014bfa1fda7f..79e372cdde49f724f22091f08d7a7100c4b838dd

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 27 Oct 2017 18:31:28 +0000 (UTC)

0caa654  update 05 changelog

-- 
You are receiving this because you are subscribed to this thread.
View it on GitHub:
https://github.com/httpwg/http-extensions/pull/373/files/79e372cdde49f724f22091f08d7a7100c4b838dd..0caa65480bc3011b5c44f46ebd0b60223d72f22a

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 27 Oct 2017 18:47:51 +0000 (UTC)

Merged #373.

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#event-1314489843

---

From: HTTP issue updates <[email-masked]>
Date: Fri, 27 Oct 2017 11:50:12 -0700

> @mnot I think it'd be good to see #373 in situ; from what I see in the patch, I think it's strictly better. No guarantees that there aren't other issues, or that this isn't completely covered, but personally I think it's better. - https://github.com/httpwg/http-extensions/issues/372#issuecomment-339513412

Squashed & merged. @martinthomson thanks for your help here and let me know if there is anything else I should address (in a separate PR :)). 

-- 
You are receiving this because you are subscribed to this thread.
Reply to this email directly or view it on GitHub:
https://github.com/httpwg/http-extensions/pull/373#issuecomment-340055219